#include <unistd.h>
#include <pwd.h>
#include <grp.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "access.h"

#include <stdio.h>

bool getMassAccess( void ) {
// user:
	uid_t uid = getuid();
//	printf( "uid=%d\n",uid );
	if( uid == ROOT_UID ) {
//		printf( "It's Root!\n" );
		return true;	// system root
	}
	struct passwd* pw = getpwuid( uid );
	char* userName = pw->pw_name;

// massRoot-group:
	setgrent(); // to begin
	struct group* gr = getgrgid( MASS_ROOT_GID);
//	printf( "gr_name=%s gr_gid=%d\n",
//		gr->gr_name, gr->gr_gid );

	int i = 0;
	char** mem = gr->gr_mem;
	while( mem[i] ) {
//		printf( "%s ?\n",mem[i] );
		if( strcmp( mem[i], userName ) == 0 ) {
//			printf( "%s is MassRoot!\n",userName );
			return true;
		}
		i++;
	}
//	printf( "%s is User!\n",userName );
	return false;
}

void setAccess( const char* fileName, bool toMassRoot ) {
	gid_t gid;
	if( toMassRoot ) gid = (gid_t)MASS_ROOT_GID;
	else gid = (gid_t)MASS_GID;

	chown( fileName, (uid_t) -1, gid );
	chmod( fileName, S_IRUSR | S_IWUSR |
			S_IRGRP | S_IWGRP | S_IROTH );
}

/*
int main( int argc, char ** argv ) {
	getMassAccess();
}
*/