#include "devicetree.h"

CFGTree* DeviceTree::linkDeviceTree( void ) {

leaf_blocksize.initLeaf("DataBlockSize");
leaf_wtime.initLeaf("WindowTime");

leaf_set_lev.initLeaf( "SetLevel" );
leaf_get_lev.initLeaf( "GetLevel" );
leaf_set_exp.initLeaf( "SetExpos" );
leaf_get_exp.initLeaf( "GetExpos" );
leaf_set_numb.initLeaf( "SetNumber" );
leaf_get_numb.initLeaf( "GetNumber" );
leaf_get_stat_count.initLeaf( "GetStatus" );
leaf_set_blsize.initLeaf( "SetBlSize" );
leaf_get_blsize.initLeaf( "GetBlSize" );
leaf_set_induc.initLeaf( "SetInduc" );
leaf_get_induc.initLeaf( "GetInduc" );
leaf_get_data.initLeaf( "GetData" );
leaf_get_ident_count.initLeaf( "GetIdent" );
leaf_get_crc_count.initLeaf( "GetCRC" );
leaf_get_const_count.initLeaf( "GetConst" );
leaf_run_mst.initLeaf( "Run" );
leaf_stop.initLeaf( "Stop" );
leaf_master_on.initLeaf( "MasterOn" );
leaf_master_off.initLeaf( "MasterOff" );
leaf_run_test.initLeaf( "RunTest" );
leaf_reset_count.initLeaf( "Reset" );
leaf_active_on.initLeaf( "ActiveOn" );
leaf_active_off.initLeaf( "ActiveOff" );
leaf_induce_on.initLeaf( "InduceOn" );
leaf_induce_off.initLeaf( "InduceOff" );
leaf_shorter.initLeaf( "Shorter" );
leaf_longer.initLeaf( "Longer" );

leaf_mod_1.initLeaf( "Module" );
leaf_ident_1.initLeaf( "Identification" );
leaf_pmt_1.initLeaf( "PMTNumber" );
leaf_discr_1.initLeaf("Discrimination","float" );
leaf_nlin_1.initLeaf("NonLinearity","float");
leaf_npois_1.initLeaf("NonPoisson","float");

leaf_mod_2.initLeaf( "Module" );
leaf_pmt_2.initLeaf( "PMTNumber" );
leaf_ident_2.initLeaf( "Identification" );
leaf_discr_2.initLeaf("Discrimination","float" );
leaf_nlin_2.initLeaf("NonLinearity","float");
leaf_npois_2.initLeaf("NonPoisson","float");

leaf_mod_3.initLeaf( "Module" );
leaf_pmt_3.initLeaf( "PMTNumber" );
leaf_ident_3.initLeaf( "Identification" );
leaf_discr_3.initLeaf("Discrimination","float" );
leaf_nlin_3.initLeaf("NonLinearity","float");
leaf_npois_3.initLeaf("NonPoisson","float");

leaf_mod_4.initLeaf( "Module" );
leaf_pmt_4.initLeaf( "PMTNumber" );
leaf_ident_4.initLeaf( "Identification" );
leaf_discr_4.initLeaf("Discrimination","float" );
leaf_nlin_4.initLeaf("NonLinearity","float");
leaf_npois_4.initLeaf("NonPoisson","float");

leaf_mod_5.initLeaf( "Module" );
leaf_pmt_5.initLeaf( "PMTNumber" );
leaf_ident_5.initLeaf( "Identification" );
leaf_discr_5.initLeaf("Discrimination","float" );
leaf_nlin_5.initLeaf("NonLinearity","float");
leaf_npois_5.initLeaf("NonPoisson","float");

leaf_set_volt.initLeaf( "SetVoltage" );
leaf_get_volt.initLeaf( "GetVoltage" );
leaf_get_stat_hv.initLeaf( "GetStatus" );
leaf_get_crc_hv.initLeaf( "GetCRC" );
leaf_high_on.initLeaf( "HighOn" );
leaf_high_off.initLeaf( "HighOff" );
leaf_get_temper.initLeaf( "GetTemper" );
leaf_saf_on.initLeaf( "SafetyOn" );
leaf_saf_off.initLeaf( "SafetyOff" );
leaf_get_ident_hv.initLeaf( "GetIdent" );
leaf_get_const_hv.initLeaf( "GetConst" );
leaf_reset_hv.initLeaf( "Reset" );
leaf_mod_hv.initLeaf( "Module" );
leaf_ident_hv.initLeaf( "Identification" );

leaf_set_illum.initLeaf( "SetIllum" );
leaf_get_illum.initLeaf( "GetIllum" );
leaf_set_light.initLeaf( "SetLight" );
leaf_get_light.initLeaf( "GetLight" );
leaf_l_get_crc.initLeaf( "GetCRC" );
leaf_set_par.initLeaf( "SetParam" );
leaf_get_par.initLeaf( "GetParam" );
leaf_get_stat_light.initLeaf( "GetStatus" );
leaf_set_vampl.initLeaf( "SetVAmpl" );
leaf_get_vampl.initLeaf( "GetVAmpl" );
leaf_set_bmode.initLeaf( "SetBMode" );
leaf_get_bmode.initLeaf( "GetBMode" );
leaf_illum_on.initLeaf( "IllumOn" );
leaf_illum_off.initLeaf( "IllumOff" );
leaf_light_on.initLeaf( "LightOn" );
leaf_light_off.initLeaf( "LightOff" );
leaf_vary_on.initLeaf( "VaryOn" );
leaf_vary_off.initLeaf( "VaryOff" );
leaf_butt_lock.initLeaf( "ButtLock" );
leaf_butt_unlock.initLeaf( "ButtUnLock" );
leaf_get_ident_light.initLeaf( "GetIdent" );
leaf_get_const_light.initLeaf( "GetConst" );
leaf_reset_light.initLeaf( "Reset" );

leaf_mod_light.initLeaf( "Module" );
leaf_ident_light.initLeaf( "Identification" );

leaf_b_ap.initLeaf( "Apertures","int" );
leaf_b_ill.initLeaf( "Illumination","int" );
leaf_b_shft.initLeaf( "FineShift","int" );
leaf_b_door.initLeaf( "InputDoor","int" );

leaf_motor_get_stat.initLeaf("GetStatus");
leaf_motor_get_sens.initLeaf("GetSensors");
leaf_motor_get_crc.initLeaf("GetCRC");
leaf_motor_get_pos.initLeaf("GetPosition");
leaf_motor_move.initLeaf("MoveTo");
leaf_motor_sh.initLeaf("ShiftAt");
leaf_motor_sync.initLeaf("SynchAt");
leaf_motor_stop.initLeaf("StopMotion");
leaf_motor_load_stop.initLeaf("LoadStops");
leaf_motor_get_stop.initLeaf("GetStops");
leaf_motor_set_ap.initLeaf("SetAperture");
leaf_motor_get_ap.initLeaf("GetAperture");
leaf_motor_set_step.initLeaf("SetStep");
leaf_motor_get_step.initLeaf("GetStep");
leaf_motor_test_mov.initLeaf("TestMotion");
leaf_motor_null.initLeaf("NullSet");
leaf_motor_open_cov.initLeaf("OpenDoor");
leaf_motor_close_cov.initLeaf("CloseDoor");
leaf_motor_power.initLeaf("PowerDown");
leaf_get_ident_motor.initLeaf( "GetIdent" );
leaf_get_const_motor.initLeaf( "GetConst" );
leaf_reset_motor.initLeaf( "Reset" );
leaf_mod_motor.initLeaf( "Module" );
leaf_ident_motor.initLeaf( "Identification" );

leaf_track_get_stat.initLeaf("GetStatus");
leaf_track_get_crc.initLeaf("GetCRC");
leaf_track_shift_ra.initLeaf("ShiftRA");
leaf_track_shift_dec.initLeaf("ShiftDec");
leaf_track_move_ra.initLeaf("MoveRA");
leaf_track_move_dec.initLeaf("MoveDec");
leaf_track_force.initLeaf("ForceMotion");
leaf_track_stop.initLeaf("StopMotion");
leaf_track_test_mov.initLeaf("TestMotion");
leaf_track_get_ident.initLeaf( "GetIdent" );
leaf_track_get_const.initLeaf( "GetConst" );
leaf_track_reset.initLeaf( "Reset" );
leaf_track_mod.initLeaf( "Module" );
leaf_track_ident.initLeaf( "Identification" );
leaf_track_control_base.initLeaf("ControlBase");

leaf_inner_a.initLeaf("Inner","float");
leaf_outer_a.initLeaf("Outer","float");

leaf_inner_b.initLeaf("Inner","float");
leaf_outer_b.initLeaf("Outer","float");

leaf_inner_c.initLeaf("Inner","float");
leaf_outer_c.initLeaf("Outer","float");

leaf_inner_d.initLeaf("Inner","float");
leaf_outer_d.initLeaf("Outer","float");

leaf_centr_s.initLeaf("EdgeAngle1","float");
leaf_center_angl.initLeaf("EdgeAngle2","float");
leaf_scale.initLeaf("WheelStep","float");
leaf_magn.initLeaf("Magnification","float");

leaf_flen_fabry.initLeaf("FocalLength","float");
leaf_pos_fabry.initLeaf("Position","float");

leaf_flen_feed.initLeaf("FocalLength","float");
leaf_entrloc.initLeaf("EntrLocation","float");

leaf_min_alt.initLeaf("MinAltitude","float");
leaf_max_alt.initLeaf("MaxAltitude","float");
leaf_step.initLeaf("Step","float");
leaf_min_step.initLeaf("MinStep","float");

branch_count.initBranch( "Counters" );
	branch_command.initBranch( "Command" );
	branch_common.initBranch( "Common" );
	branch_count_1.initBranch( "Counter 1" );
	branch_count_2.initBranch( "Counter 2" );
	branch_count_3.initBranch( "Counter 3" );
	branch_count_4.initBranch( "Counter 4" );
	branch_count_5.initBranch( "Counter 5" );
branch_light.initBranch( "Lighters & Buttons" );
	branch_l_command.initBranch( "Command" );
	branch_l_common.initBranch( "Common" );
	branch_butmod.initBranch( "ButtonModes" );
branch_hv.initBranch( "HV power" );
	branch_hv_command.initBranch( "Command" );
	branch_hv_common.initBranch( "Common" );
branch_motor.initBranch( "Apertures" );
	branch_m_command.initBranch( "Command" );
	branch_m_common.initBranch( "Common" );
branch_track.initBranch( "Tracker" );
	branch_t_command.initBranch( "Command" );
	branch_t_common.initBranch( "Common" );
branch_segm.initBranch("Segmentator");
	branch_a_opt.initBranch("Channel A");
	branch_b_opt.initBranch("Channel B");
	branch_c_opt.initBranch("Channel C");
	branch_d_opt.initBranch("Channel D");
branch_optic.initBranch("Optics");
	branch_common_opt.initBranch("Common");
	branch_fabry.initBranch("Fabry lens");
	branch_feed.initBranch("Feeding optics");
branch_weight.initBranch("WeightFunction");

link_count.initLink( 'b',&branch_count,&tree );
	link_command.initLink( 'b',&branch_command,&branch_count );

		link_set_lev.initLink( 'l',&leaf_set_lev,&branch_command );
		link_get_lev.initLink( 'l',&leaf_get_lev,&branch_command );
		link_set_exp.initLink( 'l',&leaf_set_exp,&branch_command );
		link_get_exp.initLink( 'l',&leaf_get_exp,&branch_command );
		link_set_numb.initLink( 'l',&leaf_set_numb,&branch_command );
		link_get_numb.initLink( 'l',&leaf_get_numb,&branch_command );
		link_get_stat_count.initLink( 'l',&leaf_get_stat_count,&branch_command );
		link_set_blsize.initLink( 'l',&leaf_set_blsize,&branch_command );
		link_get_blsize.initLink( 'l',&leaf_get_blsize,&branch_command );
		link_set_induc.initLink( 'l',&leaf_set_induc,&branch_command );
		link_get_induc.initLink( 'l',&leaf_get_induc,&branch_command );
		link_get_data.initLink( 'l',&leaf_get_data,&branch_command );
		link_get_ident_count.initLink( 'l',&leaf_get_ident_count,&branch_command );
		link_get_crc_count.initLink( 'l',&leaf_get_crc_count,&branch_command );
		link_get_const_count.initLink( 'l',&leaf_get_const_count,&branch_command );
		link_run_mst.initLink( 'l',&leaf_run_mst,&branch_command );
		link_stop.initLink( 'l',&leaf_stop,&branch_command );
		link_master_on.initLink( 'l',&leaf_master_on,&branch_command );
		link_master_off.initLink( 'l',&leaf_master_off,&branch_command );
		link_run_test.initLink( 'l',&leaf_run_test,&branch_command );
		link_reset_count.initLink( 'l',&leaf_reset_count,&branch_command );
		link_active_on.initLink( 'l',&leaf_active_on,&branch_command );
		link_active_off.initLink( 'l',&leaf_active_off,&branch_command );
		link_induce_on.initLink( 'l',&leaf_induce_on,&branch_command );
		link_induce_off.initLink( 'l',&leaf_induce_off,&branch_command );
		link_shorter.initLink( 'l',&leaf_shorter,&branch_command );
		link_longer.initLink( 'l',&leaf_longer,&branch_command );

	link_common.initLink( 'b',&branch_common,&branch_count );
		link_blocksize.initLink('l',&leaf_blocksize,&branch_common );
		link_wtime.initLink('l',&leaf_wtime,&branch_common );

	link_count_1.initLink( 'b',&branch_count_1,&branch_count );
		link_mod_1.initLink( 'l',&leaf_mod_1,&branch_count_1 );
		link_pmt_1.initLink( 'l',&leaf_pmt_1,&branch_count_1 );
		link_ident_1.initLink( 'l',&leaf_ident_1,&branch_count_1 );
		link_discr_1.initLink( 'l',&leaf_discr_1,&branch_count_1 );
		link_nlin_1.initLink( 'l',&leaf_nlin_1,&branch_count_1 );
		link_npois_1.initLink( 'l',&leaf_npois_1,&branch_count_1 );

	link_count_2.initLink( 'b',&branch_count_2,&branch_count );
		link_mod_2.initLink( 'l',&leaf_mod_2,&branch_count_2 );
		link_pmt_2.initLink( 'l',&leaf_pmt_2,&branch_count_2 );
		link_ident_2.initLink( 'l',&leaf_ident_2,&branch_count_2 );
		link_discr_2.initLink( 'l',&leaf_discr_2,&branch_count_2 );
		link_nlin_2.initLink( 'l',&leaf_nlin_2,&branch_count_2 );
		link_npois_2.initLink( 'l',&leaf_npois_2,&branch_count_2 );

	link_count_3.initLink( 'b',&branch_count_3,&branch_count );
		link_mod_3.initLink( 'l',&leaf_mod_3,&branch_count_3 );
		link_pmt_3.initLink( 'l',&leaf_pmt_3,&branch_count_3 );
		link_ident_3.initLink( 'l',&leaf_ident_3,&branch_count_3 );
		link_discr_3.initLink( 'l',&leaf_discr_3,&branch_count_3 );
		link_nlin_3.initLink( 'l',&leaf_nlin_3,&branch_count_3 );
		link_npois_3.initLink( 'l',&leaf_npois_3,&branch_count_3 );

	link_count_4.initLink( 'b',&branch_count_4,&branch_count );
		link_mod_4.initLink( 'l',&leaf_mod_4,&branch_count_4 );
		link_pmt_4.initLink( 'l',&leaf_pmt_4,&branch_count_4 );
		link_ident_4.initLink( 'l',&leaf_ident_4,&branch_count_4 );
		link_discr_4.initLink( 'l',&leaf_discr_4,&branch_count_4 );
		link_nlin_4.initLink( 'l',&leaf_nlin_4,&branch_count_4 );
		link_npois_4.initLink( 'l',&leaf_npois_4,&branch_count_4 );

	link_count_5.initLink( 'b',&branch_count_5,&branch_count );
		link_mod_5.initLink( 'l',&leaf_mod_5,&branch_count_5 );
		link_pmt_5.initLink( 'l',&leaf_pmt_5,&branch_count_5 );
		link_ident_5.initLink( 'l',&leaf_ident_5,&branch_count_5 );
		link_discr_5.initLink( 'l',&leaf_discr_5,&branch_count_5 );
		link_nlin_5.initLink( 'l',&leaf_nlin_5,&branch_count_5 );
		link_npois_5.initLink( 'l',&leaf_npois_5,&branch_count_5 );

link_light.initLink( 'b',&branch_light,&tree );
	link_l_command.initLink( 'b',&branch_l_command,&branch_light );
		link_set_illum.initLink( 'l',&leaf_set_illum,&branch_l_command );
		link_get_illum.initLink( 'l',&leaf_get_illum,&branch_l_command );
		link_set_light.initLink( 'l',&leaf_set_light,&branch_l_command );
		link_get_light.initLink( 'l',&leaf_get_light,&branch_l_command );
		link_l_get_crc.initLink( 'l',&leaf_l_get_crc,&branch_l_command );
		link_get_stat_light.initLink( 'l',&leaf_get_stat_light,&branch_l_command );
		link_set_vampl.initLink( 'l',&leaf_set_vampl,&branch_l_command );
		link_get_vampl.initLink( 'l',&leaf_get_vampl,&branch_l_command );
		link_set_bmode.initLink( 'l',&leaf_set_bmode,&branch_l_command );
		link_get_bmode.initLink( 'l',&leaf_get_bmode,&branch_l_command );
		link_set_par.initLink( 'l',&leaf_set_par,&branch_l_command );
		link_get_par.initLink( 'l',&leaf_get_par,&branch_l_command );
		link_illum_on.initLink( 'l',&leaf_illum_on,&branch_l_command );
		link_illum_off.initLink( 'l',&leaf_illum_off,&branch_l_command );
		link_light_on.initLink( 'l',&leaf_light_on,&branch_l_command );
		link_light_off.initLink( 'l',&leaf_light_off,&branch_l_command );
		link_vary_on.initLink( 'l',&leaf_vary_on,&branch_l_command );
		link_vary_off.initLink( 'l',&leaf_vary_off,&branch_l_command );
		link_butt_lock.initLink( 'l',&leaf_butt_lock,&branch_l_command );
		link_butt_unlock.initLink( 'l',&leaf_butt_unlock,&branch_l_command );
		link_get_ident_light.initLink( 'l',&leaf_get_ident_light,&branch_l_command );
		link_get_const_light.initLink( 'l',&leaf_get_const_light,&branch_l_command );
		link_reset_light.initLink( 'l',&leaf_reset_light,&branch_l_command );
	link_l_common.initLink( 'b',&branch_l_common,&branch_light );
		link_module_light.initLink( 'l',&leaf_mod_light,&branch_l_common );
		link_ident_light.initLink( 'l',&leaf_ident_light,&branch_l_common );
	link_butmod.initLink( 'b',&branch_butmod,&branch_light );
		link_b_ap.initLink( 'l',&leaf_b_ap,&branch_butmod );
		link_b_ill.initLink( 'l',&leaf_b_ill,&branch_butmod );
		link_b_shft.initLink( 'l',&leaf_b_shft,&branch_butmod );
		link_b_door.initLink( 'l',&leaf_b_door,&branch_butmod );
link_hv.initLink( 'b',&branch_hv,&tree );
	link_hv_command.initLink( 'b',&branch_hv_command,&branch_hv );
		link_set_volt.initLink( 'l',&leaf_set_volt,&branch_hv_command );
		link_get_volt.initLink( 'l',&leaf_get_volt,&branch_hv_command );
		link_get_stat_hv.initLink( 'l',&leaf_get_stat_hv,&branch_hv_command );
		link_get_crc_hv.initLink( 'l',&leaf_get_crc_hv,&branch_hv_command );
		link_high_on.initLink( 'l',&leaf_high_on,&branch_hv_command );
		link_high_off.initLink( 'l',&leaf_high_off,&branch_hv_command );
		link_get_temper.initLink( 'l',&leaf_get_temper,&branch_hv_command );
		link_saf_on.initLink( 'l',&leaf_saf_on,&branch_hv_command );
		link_saf_off.initLink( 'l',&leaf_saf_off,&branch_hv_command );
		link_get_ident_hv.initLink( 'l',&leaf_get_ident_hv,&branch_hv_command );
		link_get_const_hv.initLink( 'l',&leaf_get_const_hv,&branch_hv_command );
		link_reset_hv.initLink( 'l',&leaf_reset_hv,&branch_hv_command );
	link_hv_common.initLink( 'b',&branch_hv_common,&branch_hv );
		link_module_hv.initLink( 'l',&leaf_mod_hv,&branch_hv_common );
		link_ident_hv.initLink( 'l',&leaf_ident_hv,&branch_hv_common );
link_motor.initLink( 'b',&branch_motor,&tree );
	link_m_command.initLink( 'b',&branch_m_command,&branch_motor );
		link_motor_get_stat.initLink( 'l',&leaf_motor_get_stat,&branch_m_command );
		link_motor_get_sens.initLink( 'l',&leaf_motor_get_sens,&branch_m_command );
		link_motor_get_crc.initLink( 'l',&leaf_motor_get_crc,&branch_m_command );
		link_motor_get_pos.initLink( 'l',&leaf_motor_get_pos,&branch_m_command );
		link_motor_move.initLink( 'l',&leaf_motor_move,&branch_m_command );
		link_motor_sh.initLink( 'l',&leaf_motor_sh,&branch_m_command );
		link_motor_sync.initLink( 'l',&leaf_motor_sync,&branch_m_command );
		link_motor_stop.initLink( 'l',&leaf_motor_stop,&branch_m_command );
		link_motor_load_stop.initLink( 'l',&leaf_motor_load_stop,&branch_m_command );
		link_motor_get_stop.initLink( 'l',&leaf_motor_get_stop,&branch_m_command );
		link_motor_set_ap.initLink( 'l',&leaf_motor_set_ap,&branch_m_command );
		link_motor_get_ap.initLink( 'l',&leaf_motor_get_ap,&branch_m_command );
		link_motor_set_step.initLink( 'l',&leaf_motor_set_step,&branch_m_command );
		link_motor_get_step.initLink( 'l',&leaf_motor_get_step,&branch_m_command );
		link_motor_test_mov.initLink( 'l',&leaf_motor_test_mov,&branch_m_command );
		link_motor_null.initLink( 'l',&leaf_motor_null,&branch_m_command );
		link_motor_open_cov.initLink( 'l',&leaf_motor_open_cov,&branch_m_command );
		link_motor_close_cov.initLink( 'l',&leaf_motor_close_cov,&branch_m_command );
		link_motor_power.initLink( 'l',&leaf_motor_power,&branch_m_command );

		link_get_ident_motor.initLink( 'l',&leaf_get_ident_motor,&branch_m_command );
		link_get_const_motor.initLink( 'l',&leaf_get_const_motor,&branch_m_command );
		link_reset_motor.initLink( 'l',&leaf_reset_motor,&branch_m_command );

	link_m_common.initLink( 'b',&branch_m_common,&branch_motor );
		link_module_motor.initLink( 'l',&leaf_mod_motor,&branch_m_common );
		link_ident_motor.initLink( 'l',&leaf_ident_motor,&branch_m_common );

link_track.initLink( 'b',&branch_track,&tree );
	link_t_command.initLink( 'b',&branch_t_command,&branch_track );
		link_track_get_stat.initLink( 'l',&leaf_track_get_stat,&branch_t_command );
		link_track_get_crc.initLink( 'l',&leaf_track_get_crc,&branch_t_command );
		link_track_shift_ra.initLink( 'l',&leaf_track_shift_ra,&branch_t_command );
		link_track_shift_dec.initLink( 'l',&leaf_track_shift_dec,&branch_t_command );
		link_track_move_ra.initLink( 'l',&leaf_track_move_ra,&branch_t_command );
		link_track_move_dec.initLink( 'l',&leaf_track_move_dec,&branch_t_command );
		link_track_force.initLink( 'l',&leaf_track_force,&branch_t_command );
		link_track_stop.initLink( 'l',&leaf_track_stop,&branch_t_command );
		link_track_test_mov.initLink( 'l',&leaf_track_test_mov,&branch_t_command );
		link_track_get_ident.initLink( 'l',&leaf_track_get_ident,&branch_t_command );
		link_track_get_const.initLink( 'l',&leaf_track_get_const,&branch_t_command );
		link_track_reset.initLink( 'l',&leaf_track_reset,&branch_t_command );

	link_t_common.initLink( 'b',&branch_t_common,&branch_track );
		link_track_mod.initLink( 'l',&leaf_track_mod,&branch_t_common );
		link_track_ident.initLink( 'l',&leaf_track_ident,&branch_t_common );
		link_track_control_base.initLink( 'l',&leaf_track_control_base,&branch_t_common );

	link_segm.initLink('b',&branch_segm,&tree);
		link_a_segm.initLink('b',&branch_a_opt,&branch_segm);
			link_inner_a.initLink('l',&leaf_inner_a,&branch_a_opt);
			link_outer_a.initLink('l',&leaf_outer_a,&branch_a_opt);
		link_b_segm.initLink('b',&branch_b_opt,&branch_segm);
			link_inner_b.initLink('l',&leaf_inner_b,&branch_b_opt);
			link_outer_b.initLink('l',&leaf_outer_b,&branch_b_opt);
		link_c_segm.initLink('b',&branch_c_opt,&branch_segm);
			link_inner_c.initLink('l',&leaf_inner_c,&branch_c_opt);
			link_outer_c.initLink('l',&leaf_outer_c,&branch_c_opt);
		link_d_segm.initLink('b',&branch_d_opt,&branch_segm);
			link_inner_d.initLink('l',&leaf_inner_d,&branch_d_opt);
			link_outer_d.initLink('l',&leaf_outer_d,&branch_d_opt);
	link_optic.initLink('b',&branch_optic,&tree);
		link_common_opt.initLink('b',&branch_common_opt,&branch_optic);
			link_centr_s.initLink('l',&leaf_centr_s,&branch_common_opt);
			link_center_angl.initLink('l',&leaf_center_angl,&branch_common_opt);
			link_scale.initLink('l',&leaf_scale,&branch_common_opt);
			link_magn.initLink('l',&leaf_magn,&branch_common_opt);
		link_fabry.initLink('b',&branch_fabry,&branch_optic);
			link_flen_fabry.initLink('l',&leaf_flen_fabry,&branch_fabry);
			link_pos_fabry.initLink('l',&leaf_pos_fabry,&branch_fabry);
		link_feed.initLink('b',&branch_feed,&branch_optic);
			link_flen_feed.initLink('l',&leaf_flen_feed,&branch_feed);
			link_entrloc_feed.initLink('l',&leaf_entrloc,&branch_feed);
	link_weight.initLink('b',&branch_weight,&tree);
		link_min_alt.initLink('l',&leaf_min_alt,&branch_weight);
		link_max_alt.initLink('l',&leaf_max_alt,&branch_weight);
		link_step.initLink('l',&leaf_step,&branch_weight);
		link_min_step.initLink('l',&leaf_min_step,&branch_weight);

	return &tree;
}
