#include "maintree.h"

CFGTree* MainTree::linkMainTree( void ) {

//	Leafs & Branchs:

	branch_pref.initBranch("Preferences");
		branch_pref_txt.initBranch("Text window settings");
			leaf_pref_txtwin_geom.initLeaf("WindowGeometry",false);
			leaf_pref_txtfont_large.initLeaf("FontSizeLarge",false);
			leaf_pref_txtfont_small.initLeaf("FontSizeSmall",false);
		branch_pref_graph.initBranch("Graphic window settings");
			leaf_pref_graphwin_geom.initLeaf("WindowGeometry",false);
			leaf_pref_graphfont.initLeaf("FontSize",false);
			leaf_pref_graphbackgr.initLeaf("Background","color",false);
			leaf_pref_axes.initLeaf("AxesColor","color",false);
			leaf_pref_point.initLeaf("PointSize","int",false);

	branch_general.initBranch("General");
		branch_p_ver.initBranch("Program version");
			leaf_p_ver.initLeaf("Version");
			leaf_p_date.initLeaf("Date","date");
			leaf_p_modif.initLeaf("Modified");
		branch_c_ver.initBranch("Configuration version");
			leaf_c_ver.initLeaf("Version");
			leaf_c_date.initLeaf("Date","date");
			leaf_c_modif.initLeaf("Modified");
		branch_site.initBranch("Site");
			leaf_site_name.initLeaf("SiteName",false);
			leaf_long.initLeaf("Longitude","time",false,false);
			leaf_lat.initLeaf("Latitude","degree",false,false);
			leaf_tmZone.initLeaf("TimeZone","float",false,false);
			leaf_alt.initLeaf("Altitude","float",false,false);
			leaf_loc.initLeaf("Location",false,false);
			leaf_lev.initLeaf("Level","float",false,false);
		branch_inp.initBranch("Inputs");
			leaf_star.initLeaf("StarData",true,false);
			leaf_resp.initLeaf("Response",true,false);
			leaf_spec.initLeaf("SpectraDir",true,false);
			leaf_weight.initLeaf("WeightDir");
			leaf_lut.initLeaf("LutDir",true,false);
			leaf_pb.initLeaf("PlayBackDir");
		branch_out.initBranch("Outputs");
			leaf_tempdir.initLeaf("TempDir",false,false);
			leaf_raw.initLeaf("DataDir",false,false);
			leaf_log.initLeaf("LogDir",false,false);

	branch_dev.initBranch("Devices");
		branch_counters.initBranch("Counters");
			leaf_map_a.initLeaf("ChannelA",true,false);
			leaf_map_b.initLeaf("ChannelB",true,false);
			leaf_map_c.initLeaf("ChannelC",true,false);
			leaf_map_d.initLeaf("ChannelD",true,false);
		branch_aper.initBranch("Apertures");
			leaf_stop1.initLeaf("Stop1",true,false);
			leaf_stop2.initLeaf("Stop2",true,false);
			leaf_stop3.initLeaf("Stop3",true,false);
			leaf_stop4.initLeaf("Stop4",true,false);
			leaf_stop5.initLeaf("Stop5",true,false);
			leaf_stop6.initLeaf("Stop6",true,false);
			leaf_stop7.initLeaf("Stop7",true,false);
			leaf_stop8.initLeaf("Stop8",true,false);

	branch_oper.initBranch("Operations");
		branch_common_oper.initBranch("Common");
			leaf_with_device.initLeaf("WithDevice","yes",false,false);
			leaf_with_guide.initLeaf("WithAutoGuide","yes",false);
			leaf_hv.initLeaf("HighVoltage","float");
			leaf_but_tm.initLeaf("ButtonPollingTime","float",true,false);
			leaf_tmpr_tm.initLeaf("TemperPollingTime","float",true,false);
			leaf_hv_tm.initLeaf("HighPollingTime","float",true,false);
			leaf_estim_tm.initLeaf("FluxEstimationTime","float");
			leaf_sci_count_save.initLeaf("SciCountsSave","onoff",true,false);
			leaf_tech_count_save.initLeaf("TechCountsSave","onoff",true,false);
			leaf_log_save.initLeaf("LogSave","onoff",true,false);
		branch_init.initBranch("Initialization");
			leaf_init_dr.initLeaf("InputDoor","open");
			leaf_init_aper.initLeaf("InitialStop");
			leaf_init_ill.initLeaf("Illumination","onoff");
			leaf_illum.initLeaf("IlluminationLevel","float");
			leaf_init_but.initLeaf("Buttons","onoff");
			leaf_init_butmod.initLeaf("ButtonMode");
			leaf_init_hv.initLeaf("HighVoltage","onoff");
			leaf_saf.initLeaf("Safety","onoff");
			leaf_init_scen.initLeaf("InitialScenario");
			leaf_play_init_scen.initLeaf("ScenarioRun","onoff");
		branch_show_star.initBranch("Star Pointing");
			leaf_coord.initLeaf("CoordinateSystem","hara",false);
			leaf_with_app_show.initLeaf("WithAperture","apert",false);
		branch_norm.initBranch("Normal mode");
			leaf_with_app.initLeaf("WithAperture","apert");
			leaf_exp.initLeaf("Exposition","float");
			leaf_btime.initLeaf("BaseTime","float");
			leaf_acctime.initLeaf("AccumTime","float",false);
			leaf_method.initLeaf("Cn2Method","cn2method",false);
		branch_gener.initBranch("Generalized");
			leaf_g_with_app.initLeaf("WithAperture","apert");
			leaf_with_sec.initLeaf("WithSecond","apert");
			leaf_exp_gen.initLeaf("Exposition","float");
			leaf_btime_gen.initLeaf("BaseTime","float");
			leaf_sec_tm.initLeaf("SecondBaseTime","float");
			leaf_acctime_gen.initLeaf("AccumTime","float",false);
			leaf_method_gen.initLeaf("Cn2Method","cn2method",false);
		branch_focus.initBranch("Focus control");
			leaf_foc_with_app.initLeaf("WithAperture","apert");
			leaf_foc_acctime.initLeaf("AccumTime","float",false);
			leaf_foc_exp.initLeaf("Exposition","float");
			leaf_foc_start.initLeaf("ScanStart","int");
			leaf_foc_fin.initLeaf("ScanFinish","int");
			leaf_foc_def.initLeaf("DefRange","int");
			leaf_foc_sharp0.initLeaf("Sharp0","float");
			leaf_foc_scale.initLeaf("Scale","float");
		branch_center.initBranch("Star centering");
			leaf_cen_with_app.initLeaf("WithAperture","apert");
			leaf_cen_acctime.initLeaf("AccumTime","float",false);
			leaf_cen_acctime1.initLeaf("RefreshAccumTime","float",false);
			leaf_cen_exp.initLeaf("Exposition","float");
			leaf_cen_start.initLeaf("ScanStart","int");
			leaf_cen_fin.initLeaf("ScanFinish","int");
			leaf_pos_ang.initLeaf("PositionAngle","float",false);
			leaf_mirror.initLeaf("Mirror","yes",false);
			leaf_cen_centr.initLeaf("CentralZone","int");
			leaf_cen_work.initLeaf("WorkZone","int");
			leaf_cen_iter.initLeaf("MaxIteration","int");
			leaf_cen_deltx.initLeaf("CenterX1","int");
			leaf_cen_delty.initLeaf("CenterX2","int");
			leaf_speedRA.initLeaf("SpeedRA","float",false);
			leaf_speedDec.initLeaf("SpeedDec","float",false);
		branch_backgr.initBranch("Background measurement");
			leaf_bac_meth.initLeaf("Method","method");
			leaf_bac_with_app.initLeaf("WithAperture","apert");
			leaf_bac_start.initLeaf("ApertureShift","int");
			leaf_bac_fin.initLeaf("TelescopeShift","int");
			leaf_bac_cora.initLeaf("Correction");
			leaf_bac_acctime.initLeaf("AccumTime","float");
			leaf_bac_a.initLeaf("Background");
		branch_det_count.initBranch("Detectors counting measurement");
			leaf_dc_with_ap.initLeaf("WithAperture","apert");
			leaf_dc_hv.initLeaf("Voltage");
			leaf_dc_disc.initLeaf("Discrimination");
			leaf_dc_light.initLeaf("Light");
			leaf_dc_acctm.initLeaf("AccumTime","float");
		branch_det_stat.initBranch("Detectors statistics measurement");
			leaf_ds_with_ap.initLeaf("WithAperture","apert");
			leaf_ds_light.initLeaf("Light");
			leaf_ds_acctm.initLeaf("AccumTime","float");
		branch_test.initBranch("Tests");
			leaf_test_with_ap.initLeaf("WithAperture","apert");
			leaf_test_tm_exch.initLeaf("ExchangeTestTime","float");
			leaf_test_tm_det.initLeaf("DetectorTestTime","float");
			leaf_test_light.initLeaf("DetectorLight","float");
			leaf_test_a.initLeaf("TestCounts");
			leaf_test_tol.initLeaf("FluxTolerance","float");
			leaf_test_tol_pois.initLeaf("NonPoisTolerance","float");
			leaf_t_light.initLeaf("StatisticLight");
			leaf_t_ampl.initLeaf("Modulation","float");
		branch_park.initBranch("Parking");
			leaf_park_with_ap.initLeaf("WithAperture","apert");
			leaf_park_dr.initLeaf("InputDoor","open");
			leaf_park_ill.initLeaf("Illumination","onoff");
			leaf_park_but.initLeaf("Buttons","onoff");
			leaf_park_hv.initLeaf("HighVoltage","onoff");
		branch_scen.initBranch("Scenario");
			leaf_scen_1.initLeaf("Scenario_1",false);
			leaf_scen_2.initLeaf("Scenario_2",false);
			leaf_stop_scen.initLeaf("StopOnError","yes");
	branch_disp.initBranch("Display");
		branch_scan.initBranch("Scan");
			leaf_scan_ent.initLeaf("EntityList",false,true,false);
			leaf_scan_show.initLeaf("Show",false,true,false);
			leaf_scan_color.initLeaf("Color",false,true,false);
			leaf_scan_size.initLeaf("Size",false,true,false);
			leaf_scan_ref.initLeaf("Reference","refer",false,true,false);
			leaf_scan_refval.initLeaf("ReferVal","float",false,true,false);
		branch_flx.initBranch("Flux");
			leaf_flx_ent.initLeaf("EntityList",false,true,false);
			leaf_flx_show.initLeaf("Show",false,true,false);
			leaf_flx_color.initLeaf("Color",false,true,false);
			leaf_flx_size.initLeaf("Size",false,true,false);
			leaf_flx_ref.initLeaf("Reference","refer",false,true,false);
			leaf_flx_refval.initLeaf("ReferVal","float",false,true,false);
		branch_ind.initBranch("Index");
			leaf_ind_ent.initLeaf("EntityList",false,true,false);
			leaf_ind_show.initLeaf("Show",false,true,false);
			leaf_ind_color.initLeaf("Color",false,true,false);
			leaf_ind_size.initLeaf("Size",false,true,false);
			leaf_ind_ref.initLeaf("Reference","refer",false,true,false);
			leaf_ind_refval.initLeaf("ReferVal","float",false,true,false);
		branch_desi.initBranch("DESI");
			leaf_desi_ent.initLeaf("EntityList",false,true,false);
			leaf_desi_show.initLeaf("Show",false,true,false);
			leaf_desi_color.initLeaf("Color",false,true,false);
			leaf_desi_size.initLeaf("Size",false,true,false);
			leaf_desi_ref.initLeaf("Reference","refer",false,true,false);
			leaf_desi_refval.initLeaf("ReferVal","float",false,true,false);
		branch_int.initBranch("Integral");
			leaf_int_ent.initLeaf("EntityList",false,true,false);
			leaf_int_show.initLeaf("Show",false,true,false);
			leaf_int_color.initLeaf("Color",false,true,false);
			leaf_int_size.initLeaf("Size",false,true,false);
			leaf_int_ref.initLeaf("Reference","refer",false,true,false);
			leaf_int_refval.initLeaf("ReferVal","float",false,true,false);
		branch_prf.initBranch("Profile");
			leaf_prf_show.initLeaf("Show",false,true,false);
			leaf_prf_type.initLeaf("Type","prftype",false,true,false);
			leaf_prf_color.initLeaf("Color","color",false,true,false);
			leaf_prf_lut.initLeaf("LUT","lut",false,true,false);
			leaf_prf_size.initLeaf("Size",false,true,false);
			leaf_prf_ref.initLeaf("Reference","refer",false,true,false);
			leaf_prf_scale.initLeaf("Scale","float",false,true,false);
			leaf_prf_refval.initLeaf("ReferVal","float",false,true,false);
//	Link

	link_pref.initLink('b',&branch_pref,&tree);
		link_pref_txt.initLink('b',&branch_pref_txt,&branch_pref);
			link_pref_txtwin_geom.initLink('l',&leaf_pref_txtwin_geom,&branch_pref_txt);
			link_pref_txtfont_large.initLink('l',&leaf_pref_txtfont_large,&branch_pref_txt);
			link_pref_txtfont_small.initLink('l',&leaf_pref_txtfont_small,&branch_pref_txt);
		link_pref_graph.initLink('b',&branch_pref_graph,&branch_pref);
			link_pref_graphwin_geom.initLink('l',&leaf_pref_graphwin_geom,&branch_pref_graph);
			link_pref_graphfont.initLink('l',&leaf_pref_graphfont,&branch_pref_graph);
			link_pref_graphbackgr.initLink('l',&leaf_pref_graphbackgr,&branch_pref_graph);
			link_pref_axes.initLink('l',&leaf_pref_axes,&branch_pref_graph);
			link_pref_point.initLink('l',&leaf_pref_point,&branch_pref_graph);
	link_general.initLink('b',&branch_general,&tree);
		link_p_ver.initLink('b',&branch_p_ver,&branch_general);
			link_leaf_p_ver.initLink('l',&leaf_p_ver,&branch_p_ver);
			link_p_date.initLink('l',&leaf_p_date,&branch_p_ver);
			link_p_modif.initLink('l',&leaf_p_modif,&branch_p_ver);

		link_c_ver.initLink('b',&branch_c_ver,&branch_general);
			link_leaf_c_ver.initLink('l',&leaf_c_ver,&branch_c_ver);
			link_c_date.initLink('l',&leaf_c_date,&branch_c_ver);
			link_c_modif.initLink('l',&leaf_c_modif,&branch_c_ver);

		link_site.initLink('b',&branch_site,&branch_general);
			link_site_name.initLink('l',&leaf_site_name,&branch_site);
			link_long.initLink('l',&leaf_long,&branch_site);
			link_lat.initLink('l',&leaf_lat,&branch_site);
			link_tmZone.initLink('l',&leaf_tmZone,&branch_site);
			link_alt.initLink('l',&leaf_alt,&branch_site);
			link_loc.initLink('l',&leaf_loc,&branch_site);
			link_lev.initLink('l',&leaf_lev,&branch_site);
		link_inp.initLink('b',&branch_inp,&branch_general);
			link_star.initLink('l',&leaf_star,&branch_inp);
			link_spec.initLink('l',&leaf_spec,&branch_inp);
			link_resp.initLink('l',&leaf_resp,&branch_inp);
			link_weight.initLink('l',&leaf_weight,&branch_inp);
			link_lut.initLink('l',&leaf_lut,&branch_inp);
			link_pb.initLink('l',&leaf_pb,&branch_inp);

		link_out.initLink('b',&branch_out,&branch_general);
			link_tempdir.initLink('l',&leaf_tempdir,&branch_out);
			link_raw.initLink('l',&leaf_raw,&branch_out);
			link_log.initLink('l',&leaf_log,&branch_out);

	link_dev.initLink('b',&branch_dev,&tree);

		link_counters.initLink('b',&branch_counters,&branch_dev);
			link_map_a.initLink('l',&leaf_map_a,&branch_counters);
			link_map_b.initLink('l',&leaf_map_b,&branch_counters);
			link_map_c.initLink('l',&leaf_map_c,&branch_counters);
			link_map_d.initLink('l',&leaf_map_d,&branch_counters);

		link_aper.initLink('b',&branch_aper,&branch_dev);
			link_stop1.initLink('l',&leaf_stop1,&branch_aper);
			link_stop2.initLink('l',&leaf_stop2,&branch_aper);
			link_stop3.initLink('l',&leaf_stop3,&branch_aper);
			link_stop4.initLink('l',&leaf_stop4,&branch_aper);
			link_stop5.initLink('l',&leaf_stop5,&branch_aper);
			link_stop6.initLink('l',&leaf_stop6,&branch_aper);
			link_stop7.initLink('l',&leaf_stop7,&branch_aper);
			link_stop8.initLink('l',&leaf_stop8,&branch_aper);

	link_oper.initLink('b',&branch_oper,&tree);
		link_common_oper.initLink('b',&branch_common_oper,&branch_oper);
			link_with_device.initLink( 'l',&leaf_with_device,&branch_common_oper);
			link_with_guide.initLink( 'l',&leaf_with_guide,&branch_common_oper);
			link_hv.initLink('l',&leaf_hv,&branch_common_oper);
			link_but_tm.initLink('l',&leaf_but_tm,&branch_common_oper);
			link_tmpr_tm.initLink('l',&leaf_tmpr_tm,&branch_common_oper);
			link_hv_tm.initLink('l',&leaf_hv_tm,&branch_common_oper);
			link_estim_tm.initLink('l',&leaf_estim_tm,&branch_common_oper);
			link_sci_count_save.initLink('l',&leaf_sci_count_save,&branch_common_oper);
			link_tech_count_save.initLink('l',&leaf_tech_count_save,&branch_common_oper);
			link_log_save.initLink('l',&leaf_log_save,&branch_common_oper);
		link_init.initLink('b',&branch_init,&branch_oper);
			link_init_dr.initLink('l',&leaf_init_dr,&branch_init);
			link_init_aper.initLink('l',&leaf_init_aper,&branch_init);
			link_illum.initLink('l',&leaf_illum,&branch_init);
			link_init_ill.initLink('l',&leaf_init_ill,&branch_init);
			link_init_but.initLink('l',&leaf_init_but,&branch_init);
			link_init_butmod.initLink('l',&leaf_init_butmod,&branch_init);
			link_init_hv.initLink('l',&leaf_init_hv,&branch_init);
			link_saf.initLink('l',&leaf_saf,&branch_init);
			link_init_scen.initLink('l',&leaf_init_scen,&branch_init);
			link_play_init_scen.initLink('l',&leaf_play_init_scen,&branch_init);
		link_show_star.initLink('b',&branch_show_star,&branch_oper);
			link_with_app_show.initLink('l',&leaf_with_app_show,&branch_show_star);
			link_coord.initLink('l',&leaf_coord,&branch_show_star);
		link_norm.initLink('b',&branch_norm,&branch_oper);
			link_with_app.initLink('l',&leaf_with_app,&branch_norm);
			link_exp.initLink('l',&leaf_exp,&branch_norm);
			link_btime.initLink('l',&leaf_btime,&branch_norm);
			link_acctime.initLink('l',&leaf_acctime,&branch_norm);
			link_method.initLink('l',&leaf_method,&branch_norm);
		link_gener.initLink('b',&branch_gener,&branch_oper);
			link_g_with_app.initLink('l',&leaf_g_with_app,&branch_gener);
			link_with_sec.initLink('l',&leaf_with_sec,&branch_gener);
			link_exp_gen.initLink('l',&leaf_exp_gen,&branch_gener);
			link_btime_gen.initLink('l',&leaf_btime_gen,&branch_gener);
			link_sec_tm.initLink('l',&leaf_sec_tm,&branch_gener);
			link_acctime_gen.initLink('l',&leaf_acctime_gen,&branch_gener);
			link_method_gen.initLink('l',&leaf_method_gen,&branch_gener);
		link_focus.initLink('b',&branch_focus,&branch_oper);
			link_foc_with_app.initLink('l',&leaf_foc_with_app,&branch_focus);
			link_foc_acctime.initLink('l',&leaf_foc_acctime,&branch_focus);
			link_foc_exp.initLink('l',&leaf_foc_exp,&branch_focus);
			link_foc_start.initLink('l',&leaf_foc_start,&branch_focus);
			link_foc_fin.initLink('l',&leaf_foc_fin,&branch_focus);
			link_foc_def.initLink('l',&leaf_foc_def,&branch_focus);
			link_foc_sharp0.initLink('l',&leaf_foc_sharp0,&branch_focus);
			link_foc_scale.initLink('l',&leaf_foc_scale,&branch_focus);
		link_center.initLink('b',&branch_center,&branch_oper);
			link_cen_with_app.initLink('l',&leaf_cen_with_app,&branch_center);
			link_cen_acctime.initLink('l',&leaf_cen_acctime,&branch_center);
			link_cen_acctime1.initLink('l',&leaf_cen_acctime1,&branch_center);
			link_cen_exp.initLink('l',&leaf_cen_exp,&branch_center);
			link_cen_start.initLink('l',&leaf_cen_start,&branch_center);
			link_cen_fin.initLink('l',&leaf_cen_fin,&branch_center);
			link_pos_ang.initLink('l',&leaf_pos_ang,&branch_center);
			link_mirror.initLink('l',&leaf_mirror,&branch_center);
			link_cen_centr.initLink('l',&leaf_cen_centr,&branch_center);
			link_cen_work.initLink('l',&leaf_cen_work,&branch_center);
			link_cen_iter.initLink('l',&leaf_cen_iter,&branch_center);
			link_cen_deltx.initLink('l',&leaf_cen_deltx,&branch_center);
			link_cen_delty.initLink('l',&leaf_cen_delty,&branch_center);
			link_speedRA.initLink('l',&leaf_speedRA,&branch_center);
			link_speedDec.initLink('l',&leaf_speedDec,&branch_center);
		link_backgr.initLink('b',&branch_backgr,&branch_oper);
			link_bac_meth.initLink('l',&leaf_bac_meth,&branch_backgr);
			link_bac_with_app.initLink('l',&leaf_bac_with_app,&branch_backgr);
			link_bac_start.initLink('l',&leaf_bac_start,&branch_backgr);
			link_bac_fin.initLink('l',&leaf_bac_fin,&branch_backgr);
			link_bac_cora.initLink('l',&leaf_bac_cora,&branch_backgr);
			link_bac_acctime.initLink('l',&leaf_bac_acctime,&branch_backgr);
			link_bac_a.initLink('l',&leaf_bac_a,&branch_backgr);
		link_det_count.initLink('b',&branch_det_count,&branch_oper);
			link_dc_with_ap.initLink('l',&leaf_dc_with_ap,&branch_det_count);
			link_dc_hv.initLink('l',&leaf_dc_hv,&branch_det_count);
			link_dc_disc.initLink('l',&leaf_dc_disc,&branch_det_count);
			link_dc_light.initLink('l',&leaf_dc_light,&branch_det_count);
			link_dc_acctm.initLink('l',&leaf_dc_acctm,&branch_det_count);
		link_det_stat.initLink('b',&branch_det_stat,&branch_oper);
			link_ds_with_ap.initLink('l',&leaf_ds_with_ap,&branch_det_stat);
			link_ds_light.initLink('l',&leaf_ds_light,&branch_det_stat);
			link_ds_acctm.initLink('l',&leaf_ds_acctm,&branch_det_stat);
		link_test.initLink('b',&branch_test,&branch_oper);
			link_test_with_ap.initLink('l',&leaf_test_with_ap,&branch_test);
			link_test_tm_exch.initLink('l',&leaf_test_tm_exch,&branch_test);
			link_test_tm_det.initLink('l',&leaf_test_tm_det,&branch_test);
			link_test_light.initLink('l',&leaf_test_light,&branch_test);
			link_test_a.initLink('l',&leaf_test_a,&branch_test);
			link_test_tol.initLink('l',&leaf_test_tol,&branch_test);
			link_test_tol_pois.initLink('l',&leaf_test_tol_pois,&branch_test);
			link_t_light.initLink('l',&leaf_t_light,&branch_test);
			link_t_ampl.initLink('l',&leaf_t_ampl,&branch_test);
		link_park.initLink('b',&branch_park,&branch_oper);
			link_park_with_ap.initLink('l',&leaf_park_with_ap,&branch_park);
			link_park_dr.initLink('l',&leaf_park_dr,&branch_park);
			link_park_ill.initLink('l',&leaf_park_ill,&branch_park);
			link_park_but.initLink('l',&leaf_park_but,&branch_park);
			link_park_hv.initLink('l',&leaf_park_hv,&branch_park);
		link_scen.initLink('b',&branch_scen,&branch_oper);
			link_scen_1.initLink('l',&leaf_scen_1,&branch_scen);
			link_scen_2.initLink('l',&leaf_scen_2,&branch_scen);
			link_stop_scen.initLink('l',&leaf_stop_scen,&branch_scen);
	link_disp.initLink('b',&branch_disp,&tree);
		link_scan.initLink('b',&branch_scan,&branch_disp);
			link_scan_ent.initLink('l',&leaf_scan_ent,&branch_scan);
			link_scan_show.initLink('l',&leaf_scan_show,&branch_scan);
			link_scan_color.initLink('l',&leaf_scan_color,&branch_scan);
			link_scan_size.initLink('l',&leaf_scan_size,&branch_scan);
			link_scan_ref.initLink('l',&leaf_scan_ref,&branch_scan);
			link_scan_refval.initLink('l',&leaf_scan_refval,&branch_scan);
		link_flx.initLink('b',&branch_flx,&branch_disp);
			link_flx_ent.initLink('l',&leaf_flx_ent,&branch_flx);
			link_flx_show.initLink('l',&leaf_flx_show,&branch_flx);
			link_flx_color.initLink('l',&leaf_flx_color,&branch_flx);
			link_flx_size.initLink('l',&leaf_flx_size,&branch_flx);
			link_flx_ref.initLink('l',&leaf_flx_ref,&branch_flx);
			link_flx_refval.initLink('l',&leaf_flx_refval,&branch_flx);
		link_ind.initLink('b',&branch_ind,&branch_disp);
			link_ind_ent.initLink('l',&leaf_ind_ent,&branch_ind);
			link_ind_show.initLink('l',&leaf_ind_show,&branch_ind);
			link_ind_color.initLink('l',&leaf_ind_color,&branch_ind);
			link_ind_size.initLink('l',&leaf_ind_size,&branch_ind);
			link_ind_ref.initLink('l',&leaf_ind_ref,&branch_ind);
			link_ind_refval.initLink('l',&leaf_ind_refval,&branch_ind);
		link_desi.initLink('b',&branch_desi,&branch_disp);
			link_desi_ent.initLink('l',&leaf_desi_ent,&branch_desi);
			link_desi_show.initLink('l',&leaf_desi_show,&branch_desi);
			link_desi_color.initLink('l',&leaf_desi_color,&branch_desi);
			link_desi_size.initLink('l',&leaf_desi_size,&branch_desi);
			link_desi_ref.initLink('l',&leaf_desi_ref,&branch_desi);
			link_desi_refval.initLink('l',&leaf_desi_refval,&branch_desi);
		link_int.initLink('b',&branch_int,&branch_disp);
			link_int_ent.initLink('l',&leaf_int_ent,&branch_int);
			link_int_show.initLink('l',&leaf_int_show,&branch_int);
			link_int_color.initLink('l',&leaf_int_color,&branch_int);
			link_int_size.initLink('l',&leaf_int_size,&branch_int);
			link_int_ref.initLink('l',&leaf_int_ref,&branch_int);
			link_int_refval.initLink('l',&leaf_int_refval,&branch_int);
		link_prf.initLink('b',&branch_prf,&branch_disp);
			link_prf_show.initLink('l',&leaf_prf_show,&branch_prf);
			link_prf_type.initLink('l',&leaf_prf_type,&branch_prf);
			link_prf_color.initLink('l',&leaf_prf_color,&branch_prf);
			link_prf_lut.initLink('l',&leaf_prf_lut,&branch_prf);
			link_prf_size.initLink('l',&leaf_prf_size,&branch_prf);
			link_prf_ref.initLink('l',&leaf_prf_ref,&branch_prf);
			link_prf_scale.initLink('l',&leaf_prf_scale,&branch_prf);
			link_prf_refval.initLink('l',&leaf_prf_refval,&branch_prf);
	return &tree;
}
